--	Copyright (C) 2004 by neuron										  
--	aagaande@gmail.com											 
--																		  
--	This program is free software; you can redistribute it and--or modify  
--	it under the terms of the GNU General Public License as published by  
--	the Free Software Foundation; either version 2 of the License, or	 
--	(at your option) any later version.								   
--																		  
--	This program is distributed in the hope that it will be useful,	   
--	but WITHOUT ANY WARRANTY; without even the implied warranty of		
--	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		 
--	GNU General Public License for more details.						  
--																		  
--	You should have received a copy of the GNU General Public License	 
--	along with this program; if not, write to the						 
--	Free Software Foundation, Inc.,									   
--	59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 

-- TODO localize

local L = AceLibrary("AceLocale-2.2"):new("Tooltips")
L:RegisterTranslations("enUS", function() return {
	["Tooltips"] = true,
	["Description"] = "Deals with the different tooltips and adding info to mob/item tooltips",
	
	-- Menu:
	["itemToolTip"] = "Add quest and progress to tooltip",
	["itemToolTip desc"] = "This adds information about the quest a specific item/mob belongs to when you mouse over it",
	["tooltipAnchor"] = "Tooltip Anchor",
	["tooltipAnchor desc"] = "Sets the tooltip when mousing over the minion's anchor",
	
	
	-- Minion unlocked
	["MinionUnlocked"] = "Minion is unlocked",
	["PlaceMinion"] = "Place minion and lock it.\nYou can lock it by right clicking on the fubar/minimap icon.",
	
	-- zone tooltips
	["ZoneHidden"] = "Zone hidden",
	["TrackedQuests"] = "Shown quests",
	["HiddenQuests"] = "Hidden quests",
	["ZoneTips"] = "Hint : Right click to show/hide quests\n          Alt + rightclick to show all zones",
	
	-- Quest tooltips
	["Total"] = true,
	["QuestTips"] = "Hint : Alt click to show/hide objectives",
	
} end)

L:RegisterTranslations("koKR", function() return {
	["Tooltips"] = "툴팁",
	["Description"] = "애드온에 대한 툴팁 및 몬스터, 아이템에 대한 툴팁을 표시해주는 모듈입니다.",
	
	-- Menu:
	["itemToolTip"] = "퀘스트/진행 상황 툴팁에 추가",
	["itemToolTip desc"] = "퀘스트의 진행 상황을 알림창에 가져다 댔을때 툴팁에 표시해줍니다.",
	["tooltipAnchor"] = "툴팁 위치",
	["tooltipAnchor desc"] = "퀘스트 알림창의 툴팁의 위치를 설정합니다.",
	
	
	-- Minion unlocked
	["MinionUnlocked"] = "알림창 비고정",
	["PlaceMinion"] = "퀘스트 알림창을 고정할 수 있습니다.\n알림창을 고정하려면 푸바 또는 미니맵 버튼의 설정을 참고하세요.",
	
	-- zone tooltips
	["ZoneHidden"] = "지역 숨기기",
	["TrackedQuests"] = "퀘스트 보기",
	["HiddenQuests"] = "퀘스트 숨기기",
	["ZoneTips"] = "힌트 : 오른쪽 클릭하면 퀘스트를 보거나 숨기고\nAlt+클릭하면 모든 지역의 퀘스트를 볼 수 있습니다.",
	
	-- Quest tooltips
	["Total"] = "모두 보기",
	["QuestTips"] = "힌트 : Alt+클릭하면 모든 목표를 보거나 숨깁니다.",
	
} end)

local moduleName = "Tooltips"
local Tooltips = nQuestLog:NewModule(moduleName,"AceEvent-2.0","AceHook-2.1", "AceConsole-2.0")
local quixote = AceLibrary("Quixote-1.0")
local crayon = AceLibrary("Crayon-2.0")

function Tooltips:OnModuleLoad()
	self.menuName = L["Tooltips"]
	self.description = L["Description"]
	
	self.core:RegisterDefaults(moduleName, "profile", {
		["enabled"] = true,
		["itemToolTip"] = true, -- Add item/mob tooltip
		["tooltipAnchor"] = "DEFAULT",
	})
	--	{ name="Modify tooltip", type="toggle", desc="Show tooltip information when mousing over mob/item", variable="showToolTip", value=true },
	--	{ name="Tooltip anchor", type="text", desc="Decides location for the tooltip in the quest minion.", variable="tooltipAnchor", value="DEFAULT", validate={"DEFAULT","ANCHOR_TOPRIGHT", "ANCHOR_RIGHT", "ANCHOR_BOTTOMRIGHT","ANCHOR_TOPLEFT","ANCHOR_LEFT","ANCHOR_BOTTOMLEFT"} },
end

function Tooltips:ToggleEnabled(v)
	self.db.profile.enabled = v
	self:ToggleItemToolTip()
end

function Tooltips:ToggleItemToolTip()
	if (self.db.profile.itemToolTip and not self.HOOKED) then
		self.HOOKED = true
		self:RegisterEvent("UPDATE_MOUSEOVER_UNIT","OnMouseoverUnit")
		self:HookScript(GameTooltip, "OnTooltipSetItem")
	elseif (not self.db.profile.itemToolTip and self.HOOKED) then
		self.HOOKED = nil
		self:UnregisterEvent("UPDATE_MOUSEOVER_UNIT","OnMouseoverUnit")
		self:Unhook(GameTooltip, "OnTooltipSetItem")
	end
end

-- Mouseover tooltips

function Tooltips:OnMouseoverUnit()
	if quixote:IsQuestMob(UnitName('mouseover')) then
		for _,q,i,n in quixote:IterateQuestsForMob(UnitName('mouseover')) do
			GameTooltip:AddDoubleLine(q, i..'/'..n, 1, 1, 1, crayon:GetThresholdColor(i/n))
		end
		GameTooltip:Show()
	end
end

function Tooltips:OnTooltipSetItem(tooltip, ...)
	local name,got,needed = quixote:IsQuestItem(tooltip:GetItem())
	if (name) then
		tooltip:AddDoubleLine(name, got..'/'..needed, 1, 1, 1, crayon:GetThresholdColor(got/needed))
		tooltip:Show()
	end
	return self.hooks[tooltip].OnTooltipSetItem(tooltip, ...)
end

-- Minion tooltips

function Tooltips:ShowUnlockedToolTip()
	if (self.db.profile["tooltipAnchor"] == "DEFAULT") then
		GameTooltip_SetDefaultAnchor(GameTooltip, nQuestLogFrame)
	else
		GameTooltip:SetOwner(nQuestLogFrame,self.db.profile["tooltipAnchor"])
	end
	
	GameTooltip:SetText(L["MinionUnlocked"])
	GameTooltip:AddLine(L["PlaceMinion"],1,1,1,1)
	GameTooltip:Show()
end

function Tooltips:ShowZoneToolTip(zone)
	if (self.db.profile["tooltipAnchor"] == "DEFAULT") then
		GameTooltip_SetDefaultAnchor(GameTooltip, nQuestLogFrame)
	else
		GameTooltip:SetOwner(nQuestLogFrame,self.db.profile["tooltipAnchor"])
	end
	
	--Set Title text
	GameTooltip:SetText(zone)
	
	local function showZoneQuests(showHidden)
		local quests = {}
		local nQuests = 0
		for _,iQuestId in quixote:QuestsByZone(zone) do
			local title, iLevel, strTag, iGroup, iComplete, iObjectives = quixote:GetQuestById(iQuestId)
			local strObjective = quixote:GetQuestText(iQuestId)

			if (showHidden and not self.core.db.char.watchedQuests[title]) or (not showHidden and self.core.db.char.watchedQuests[title]) then
				local objectives,iTotalGot,iTotalNeeded = self.core:Format_QuestObjectives(title,iObjectives,strObjective,iQuestId,true)
				title = self.core:Format_QuestTitle(title,iLevel,strTag,iTotalGot,iTotalNeeded,iComplete)
				nQuests = nQuests + 1
				quests[title] = true
			end
		end
		return quests,nQuests
	end
	
	local function printQuests(quests)
		for name in pairs(quests) do
			GameTooltip:AddLine(name,1,0.5,0.5,0)
		end
	end
	
	if (self.core.db.char.hiddenZones[zone]) then
		GameTooltip:AddLine("  -  " .. L["ZoneHidden"],1,1,1,0)
	end
	
	local quests,nQuests = showZoneQuests(false)
	if (nQuests > 0) then
		GameTooltip:AddLine(L["TrackedQuests"] .. " (" .. nQuests .. ")",1,0.5,0.5,0)
		printQuests(quests)
	end
	
	local quests,nQuests = showZoneQuests(true)
	if (nQuests > 0) then
		GameTooltip:AddLine(L["HiddenQuests"] .. " (" .. nQuests .. ")",1,0.5,0.5,0)
		printQuests(quests)
	end
	
	GameTooltip:AddLine("\n" .. L["ZoneTips"],1,1,1,0)
	
	GameTooltip:Show()
end

function Tooltips:ShowQuestToolTip(iQuestId)
	-- TODO : layout options, ShowObjectives,ShowAll,ShowShort?
	-- TODO : maybe for example show all quest data on modifier key?
	local title, iLevel, strTag, iGroup, _, iObjectives, zone = quixote:GetQuestById(iQuestId)
	local strObjective = quixote:GetQuestText(iQuestId)
	
	if (title == nil) then
		return
	end

	

	if (self.db.profile["tooltipAnchor"] == "DEFAULT") then
		GameTooltip_SetDefaultAnchor(GameTooltip, nQuestLogFrame)
	else
		GameTooltip:SetOwner(nQuestLogFrame,self.db.profile["tooltipAnchor"])
	end


	
	--Set Title text
	GameTooltip:SetText(title)
	
	--Add objective description
	GameTooltip:AddLine(self.core:Colorize(strObjective,"objectiveText"),0.5,0.5,0.5,1)
	
	--Add progress
	local objectives,iTotalGot,iTotalNeeded = self.core:Format_QuestObjectives(title,iObjectives,strObjective,iQuestId,true)
	if (iTotalNeeded > 0) then
		local color = crayon:GetThresholdHexColor(iTotalGot / iTotalNeeded)
		objectives = "\n" .. L["Total"] .. " : " .. crayon:Colorize(color,iTotalGot .. "/" .. iTotalNeeded) .. objectives
	end
	GameTooltip:AddLine(objectives,1,1,1,0)
	
	--Add who in party has the quest:
	local ipartyMembers = GetNumPartyMembers()
	if (ipartyMembers > 0) then
		GameTooltip:AddLine("\n",1,1,1,0)
		for i = 1,ipartyMembers do
			if (IsUnitOnQuest(iQuestId, "party"..i)) then
				-- Party member is on the quest
				local strName = UnitName("party" .. i)
				
				-- Lets see if we can get quest progress too:
				local iPartyTotal = 0
				if (iObjectives > 0) then
					for i=1,iObjectives do
						local strDesc,strType, iGot, iNeeded = quixote:GetQuestStatusById(iQuestId, i)
						local iPartyGot = quixote:GetPartyQuestStatus(strName, iQuestId, strDesc)
						if (iPartyGot) then
							if (strType == "reputation") then 
								if (iNeeded == iPartyGot) then
									iPartyTotal = iPartyTotal + 1
								end
							else
								iPartyTotal = iPartyTotal + iPartyGot
							end
						end
					end
					local color = crayon:GetThresholdHexColor(iPartyTotal / iTotalNeeded)
					strName = strName .. " " .. crayon:Colorize(color,iPartyTotal .. "/" .. iTotalNeeded)
				end
				GameTooltip:AddLine(strName,0,1,0,0)
			else
				-- Party member is not on the quest
				GameTooltip:AddLine(UnitName("party" .. i),1,0,0,0)
			end
		end
	end
	
	GameTooltip:AddLine("\n" .. L["QuestTips"],1,1,1,0)
	GameTooltip:Show()
end

-- And the menu
function Tooltips:GetMenu(oldMenu)
	local menu = {
		type="group",
		name=self.menuName,
		order=oldMenu.order,
		desc=self.description,
		args = {
			toggleEnabled = oldMenu,
			itemToolTip = {
				order = oldMenu.order + 1,
				type = "toggle",
				name = L["itemToolTip"],
				desc = L["itemToolTip desc"],
				get = function()
					return self.db.profile.itemToolTip
				end,
				set = function(v)
					self.db.profile.itemToolTip = v
					self:ToggleItemToolTip()
				end,
			},
			tooltipAnchor = {
				order = oldMenu.order + 2,
				type = "text",
				name = L["tooltipAnchor"],
				desc = L["tooltipAnchor desc"],
				validate={"DEFAULT","ANCHOR_TOPRIGHT", "ANCHOR_RIGHT", "ANCHOR_BOTTOMRIGHT","ANCHOR_TOPLEFT","ANCHOR_LEFT","ANCHOR_BOTTOMLEFT"},
				get = function()
					return self.db.profile.tooltipAnchor
				end,
				set = function(v)
					self.db.profile.tooltipAnchor = v
				end,
			},
		}
	}
	return menu
end
